<?php
/**
 * @brief		Rich Discord Integration Application Class
 * @author		<a href=''>Reedzev_</a>
 * @copyright	(c) 2018 Reedzev_
 * @package		Invision Community
 * @subpackage	Rich Discord Integration
 * @since		09 Mar 2018
 * @version		
 */
 
namespace IPS\richdiscord;

/**
 * Rich Discord Integration Application Class
 */
class _Application extends \IPS\Application
{
	public function isConfigured()
    {
        return !in_array( '', [
            \IPS\Settings::i()->richdiscord_token,
            \IPS\Settings::i()->richdiscord_client_id,
            \IPS\Settings::i()->richdiscord_secret,
            \IPS\Settings::i()->richdiscord_guild
        ] );
    }

    public function clearDiscordSettings()
    {
        foreach (['invite', 'token', 'guild', 'client_id', 'secret'] as $k) {
            $k = 'richdiscord_' . $k;
            \IPS\Db::i()->update( 'core_sys_conf_settings', array( 'conf_value' => '' ), array( 'conf_key=?', $k ) );
            \IPS\Settings::i()->$k	= '';
        }
        unset( \IPS\Data\Store::i()->settings );
    }

    /**
     * ACP Menu Numbers
     *
     * @param	array	$queryString	Query String
     * @return	int
     */
    public function acpMenuNumber( $queryString )
    {
        parse_str( $queryString, $queryString );
        if ($queryString['controller'] == 'approvalqueue') {
            if (!isset(\IPS\Data\Store::i()->richdiscord_queue)) {
                \IPS\Task::constructFromData( \IPS\Db::i()->select('*', 'core_tasks', array('app=? AND `key`=?', 'richdiscord', 'refreshwaitingusers') )->first())->runAndLog();
            }
            return count(\IPS\Data\Store::i()->richdiscord_queue);
        }
    }

    public function installOther()
    {
        parent::installOther();
        $this->clearDiscordSettings();
    }
}