//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class richdiscord_hook_memberHook extends _HOOK_CLASS_
{
    public function richdiscordKick()
    {
	try
	{
	        if (!($this->richdiscord_id && \IPS\Application::load("richdiscord")->isConfigured())) {
	            return FALSE;
	        }
	        $id = $this->richdiscord_id;
	        $gid = \IPS\Settings::i()->richdiscord_guild;
	        try {
	            \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", "DELETE");
	        } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
	            return FALSE;
	        }
	        return TRUE;
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }

    public function richdiscordBan()
    {
	try
	{
	        if (!($this->richdiscord_id && \IPS\Application::load("richdiscord")->isConfigured())) {
	            return FALSE;
	        }
	        $id = $this->richdiscord_id;
	        $gid = \IPS\Settings::i()->richdiscord_guild;
	        try {
	            \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/bans/$id?delete_message_days=0&reason=", "PUT");
	        } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
	            return FALSE;
	        }
	        return TRUE;
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }

    public function richdiscordSync( $approve=TRUE, $rolesManaged=[] )
    {
	try
	{
	        if (!($this->richdiscord_id && \IPS\Application::load("richdiscord")->isConfigured())) {
	            return FALSE;
	        }
	        $id = $this->richdiscord_id;
	        $gid = \IPS\Settings::i()->richdiscord_guild;
	        if ($this->isBanned()) {
	            $this->richdiscordKick();
	            return TRUE;
	        }
	        try {
	            $member = \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id")->decodeJson();
	        } catch (\IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
	            return FALSE;
	        }
	        $rolesShouldHave = [];
	        $this->_groups = NULL;
	        $groups = $this->groups;
	        foreach ($groups as $ggid) {
	            $rolesShouldHave = array_merge($rolesShouldHave, \IPS\Member\Group::load($ggid)->g_richdiscord_roles);
	        }
	        $rolesShouldHave = array_unique($rolesShouldHave);
	        if (!count($rolesManaged)) {
	            foreach (\IPS\Member\Group::groups(TRUE, FALSE) as $k => $v) {
	                $rolesManaged = array_merge($rolesManaged, $v->g_richdiscord_roles);
	            }
	            $rolesManaged = array_unique($rolesManaged);
	        }
	        $rolesHaveNow = $member['roles'];
	        $rolesHaveManaged = array_filter($rolesHaveNow, function($val) use ($rolesManaged) {return in_array($val, $rolesManaged);});
	        if (!count($rolesHaveManaged) && !$approve) {
	            return TRUE;
	        }
	        $rolesToSet = array_merge(array_values(array_diff($rolesHaveNow, $rolesHaveManaged)), $rolesShouldHave);
	        try {
	            \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", "PATCH", json_encode([
	                'nick' => $this->name,
	                'roles' => $rolesToSet,
	            ]), 'application/json', NULL, [], TRUE);
	        } catch ( \IPS\richdiscord\Discord\Exceptions\ForbiddenException $e) {}
	        return TRUE;
	}
	catch ( \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }
}
