<?php
require_once str_replace('applications/richdiscord/interface/oauth2/accounts.php', '', str_replace('\\', '/', __FILE__)) . 'init.php';
\IPS\Session\Front::i();
$member = \IPS\Member::loggedIn();
if (!(\IPS\Application::appIsEnabled('richdiscord') && \IPS\Application::load('richdiscord')->isConfigured())) {
    \IPS\Dispatcher\External::i();
    \IPS\Output::i()->error('page_not_found', '5S100/3', 500);
}
if (!$member->member_id) {
    \IPS\Dispatcher\External::i();
    \IPS\Output::i()->error('no_module_permission_guest', '2S100/2', 403);
}
if (!\IPS\Request::i()->code) {
    \IPS\Log::log('no_oauth_code', 'discord_error');
    $_SESSION['errmsgdiscord'] = 'richdiscord_account_connect_error';
    \IPS\Output::i()->redirect(\IPS\Http\Url::internal("app=core&module=system&controller=settings&area=discord"));
} else {
    try {
        $token = \IPS\richdiscord\Discord\OAuthUtil::accessToken(\IPS\Settings::i()->richdiscord_client_id, \IPS\Settings::i()->richdiscord_secret, \IPS\Settings::i()->base_url . 'applications/richdiscord/interface/oauth2/accounts.php', \IPS\Request::i()->code)['access_token'];
        try {
            $id = \IPS\richdiscord\Discord\Requestable::request('/users/@me', 'GET', '', 'application/json', '', ["Authorization" => "Bearer $token"])->decodeJson()['id'];
            $duplicated = TRUE;
            try {
                \IPS\Db::i()->select('member_id', 'core_members', ['richdiscord_id=?', $id])->first();
            } catch ( \UnderflowException $e ) {$duplicated = FALSE;}
            if ($duplicated) {
                $_SESSION['errmsgdiscord'] = 'richdiscord_account_already_linked';
                \IPS\Output::i()->redirect(\IPS\Http\Url::internal("app=core&module=system&controller=settings&area=discord"));
            } else {
                $gid = \IPS\Settings::i()->richdiscord_guild;
                try {
                    \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", 'PUT', json_encode([
                        'access_token' => "$token",
                        'nick' => $member->name
                    ]), 'application/json', NULL, [], TRUE);
                } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $e ) {
                    try {
                        \IPS\richdiscord\Discord\Requestable::request("/guilds/$gid/members/$id", 'PATCH', json_encode([
                            'nick' => $member->name
                        ]), 'application/json', NULL, [], TRUE);
                    } catch ( \IPS\richdiscord\Discord\Exceptions\BaseException $ee ) {
                        throw $e;
                    }
                }
                $member->richdiscord_id = $id;
                $member->save();
            }
        } catch (\IPS\richdiscord\Discord\Exceptions\BaseException $e) {
            $log = \IPS\Log::log($e, 'discord_error');
            $url = \IPS\Request::i()->url();
            try {unset( $url->queryString['code'] );} catch (\Exception $e) {}
            $log->url = $url;
            $log->save();
            $_SESSION['errmsgdiscord'] = 'richdiscord_account_connect_error';
            \IPS\Output::i()->redirect(\IPS\Http\Url::internal("app=core&module=system&controller=settings&area=discord"));
        }
        try {
            \IPS\richdiscord\Discord\OAuthUtil::revoke(\IPS\Settings::i()->richdiscord_client_id, \IPS\Settings::i()->richdiscord_secret, $token);
        } catch (\Exception $e) {}
        \IPS\Output::i()->redirect(\IPS\Http\Url::internal("app=core&module=system&controller=settings&area=discord"), "saved");
    } catch (\IPS\richdiscord\Discord\Exceptions\BaseException $e) {
        $log = \IPS\Log::log($e, 'discord_error');
        $url = \IPS\Request::i()->url();
        try {unset( $url->queryString['code'] );} catch (\Exception $e) {}
        $log->url = $url;
        $log->save();
        $_SESSION['errmsgdiscord'] = 'richdiscord_account_connect_error';
        \IPS\Output::i()->redirect(\IPS\Http\Url::internal("app=core&module=system&controller=settings&area=discord"));
    }
}