<?php
namespace IPS\richdiscord\Discord;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _OAuthUtil
{
    const OAUTH_URL = 'https://discordapp.com/api/oauth2';

    public static function accessToken( $id, $secret, $redirect_uri, $code )
    {
        $r = \IPS\Http\Url::external( static::OAUTH_URL . '/token' )->request()
            ->setHeaders( [ 'Content-Type' => 'application/x-www-form-urlencoded', 'Authorization' => 'Basic ' . base64_encode("$id:$secret") ] )
            ->post( http_build_query([
                'grant_type' => 'authorization_code',
                'code' => $code,
                'redirect_uri' => $redirect_uri,
                'client_id' => $id,
                'client_secret' => $secret
            ]) );
        if (!$r->decodeJson()) return NULL;
        if (!in_array($r->httpResponseCode, [200, 201, 204, 304])) throw new \IPS\richdiscord\Discord\Exceptions\BaseException($r->httpResponseText); else return $r->decodeJson();
    }

    public static function revoke( $id, $secret, $token )
    {
        return \IPS\Http\Url::external( static::OAUTH_URL . '/token/revoke' )->request()
            ->setHeaders( ['Content-Type' => 'application/x-www-form-urlencoded' ] )
            ->login( $id, $secret )
            ->post( [
                'token' => $token,
                'client_id' => $id,
                'client_secret' => $secret
            ] );
    }

    protected final function dummy() {}
}